SM2Engine (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.crypto.engines

## Class SM2Engine

- java.lang.Object
- - org.bouncycastle.crypto.engines.SM2Engine

-     public class SM2Engine
      extends java.lang.Object

  SM2 public key encryption engine - based on https://tools.ietf.org/html/draft-shen-sm2-ecdsa-02.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SM2Engine.Mode`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SM2Engine()`
    `SM2Engine(Digest digest)`
    `SM2Engine(Digest digest, SM2Engine.Mode mode)`
    `SM2Engine(SM2Engine.Mode mode)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected ECMultiplier` | `createBasePointMultiplier()`
    `int` | `getOutputSize(int inputLen)`
    `void` | `init(boolean forEncryption, CipherParameters param)`
    `byte[]` | `processBlock(byte[] in, int inOff, int inLen)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SM2Engine

          public SM2Engine()

    - #### SM2Engine

          public SM2Engine(SM2Engine.Mode mode)

    - #### SM2Engine

          public SM2Engine(Digest digest)

    - #### SM2Engine

          public SM2Engine(Digest digest,
                           SM2Engine.Mode mode)

  - ### Method Detail

    - #### init

          public void init(boolean forEncryption,
                           CipherParameters param)

    - #### processBlock

          public byte[] processBlock(byte[] in,
                                     int inOff,
                                     int inLen)
                              throws InvalidCipherTextException

      Throws:
        `InvalidCipherTextException`

    - #### getOutputSize

          public int getOutputSize(int inputLen)

    - #### createBasePointMultiplier

          protected ECMultiplier createBasePointMultiplier()